/*
    Very Simple Compiler (Tokenizer part)
        $Id$
 */

#include <stdio.h>
#include "s-compile.h"

void error(char *e, SourcePtr s);

void
token(SourcePtr s, TokenPtr t)
{
    int c,d;

    s->last_ptr = s->ptr;  /* for error position */
    c= *s->ptr;
    if(!c) {
        t->last_token = EOF;
        return ;
    }
    s->ptr++;
    if (c<=' ') {       /* comment */ 
        while(*s->ptr++);
        s->ptr--;
        t->last_token = EOF;
        s->last_ptr = s->ptr;
        return ;
    }
    if('0'<=c && c<='9') {     /* Decimal */
        d = c-'0';
        while((c= *s->ptr++)) {
            if('0'<=c && c<='9') {
                d = d*10 + (c - '0');
            } else {
                break;
            }
        }
        if (c!=0) s->ptr--;
        t->value = d;
        t->last_token = '0';
        return ;
    } else if ('a'<=c && c<='z') {    /* variable */
        t->value = c-'a';                /* return variable reference */
        t->last_token = 'v';
        return ;
    } else {
        t->last_token = c;
        return ;
    }
}

void
error(char *e,SourcePtr s)
{
    fprintf(stderr,"%s on %s\n",e,s->last_ptr);
}



/* end */
